<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: SDImageCoder.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_77ebe3071d97df245b5e45385777f804.html">DKCameraPicker</a></li><li class="navelem"><a class="el" href="dir_43f5ca2fe4733652d7a8272cdd759b0e.html">SDWebImage.framework</a></li><li class="navelem"><a class="el" href="dir_6fcdee285dd3b624c094a59c9350aa1b.html">Headers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SDImageCoder.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * This file is part of the SDWebImage package.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * (c) Olivier Poitrey &lt;rs@dailymotion.com&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * For the full copyright and license information, please view the LICENSE</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * file that was distributed with this source code.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &lt;Foundation/Foundation.h&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#import &quot;SDWebImageCompat.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#import &quot;NSData+ImageContentType.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">typedef</span> NSString * SDImageCoderOption NS_STRING_ENUM;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">typedef</span> NSDictionary&lt;SDImageCoderOption, id&gt; SDImageCoderOptions;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">typedef</span> NSMutableDictionary&lt;SDImageCoderOption, id&gt; SDImageCoderMutableOptions;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#pragma mark - Coder Options</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// These options are for image decoding</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"></span>FOUNDATION_EXPORT SDImageCoderOption _Nonnull <span class="keyword">const</span> SDImageCoderDecodeFirstFrameOnly;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;FOUNDATION_EXPORT SDImageCoderOption _Nonnull <span class="keyword">const</span> SDImageCoderDecodeScaleFactor;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">// These options are for image encoding</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"></span>FOUNDATION_EXPORT SDImageCoderOption _Nonnull <span class="keyword">const</span> SDImageCoderEncodeFirstFrameOnly;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;FOUNDATION_EXPORT SDImageCoderOption _Nonnull <span class="keyword">const</span> SDImageCoderEncodeCompressionQuality;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;FOUNDATION_EXPORT SDImageCoderOption _Nonnull <span class="keyword">const</span> SDImageCoderWebImageContext;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#pragma mark - Coder</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="protocol_s_d_image_coder-p.html">   56</a></span>&#160;<span class="keyword">@protocol </span><a class="code" href="protocol_s_d_image_coder-p.html">SDImageCoder</a> &lt;NSObject&gt;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">@required</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#pragma mark - Decoding</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;- (BOOL)canDecodeFromData:(nullable NSData *)data;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;- (nullable UIImage *)decodedImageWithData:(nullable NSData *)data</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                                   options:(nullable SDImageCoderOptions *)options;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor">#pragma mark - Encoding</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;- (BOOL)canEncodeToFormat:(SDImageFormat)format NS_SWIFT_NAME(canEncode(to:));</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;- (nullable NSData *)encodedDataWithImage:(nullable UIImage *)image</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                                   format:(SDImageFormat)format</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                                  options:(nullable SDImageCoderOptions *)options;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">@end</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#pragma mark - Progressive Coder</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div><div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="protocol_s_d_progressive_image_coder-p.html">  114</a></span>&#160;<span class="keyword">@protocol </span><a class="code" href="protocol_s_d_progressive_image_coder-p.html">SDProgressiveImageCoder</a> &lt;<a class="code" href="protocol_s_d_image_coder-p.html">SDImageCoder</a>&gt;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">@required</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;- (BOOL)canIncrementalDecodeFromData:(nullable NSData *)data;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160; </div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;- (nonnull instancetype)initIncrementalWithOptions:(nullable SDImageCoderOptions *)options;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160; </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;- (void)updateIncrementalData:(nullable NSData *)data finished:(BOOL)finished;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;- (nullable UIImage *)incrementalDecodedImageWithOptions:(nullable SDImageCoderOptions *)options;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="keyword">@end</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="preprocessor">#pragma mark - Animated Image Provider</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div><div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="protocol_s_d_animated_image_provider-p.html">  157</a></span>&#160;<span class="keyword">@protocol </span><a class="code" href="protocol_s_d_animated_image_provider-p.html">SDAnimatedImageProvider</a> &lt;NSObject&gt;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="keyword">@required</span></div><div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="protocol_s_d_animated_image_provider-p.html#a193999acb7f5c1c07a261ffee7820107">  166</a></span>&#160;<span class="keyword">@property</span> (nonatomic, copy, readonly, nullable) NSData *<a class="code" href="protocol_s_d_animated_image_provider-p.html#a193999acb7f5c1c07a261ffee7820107">animatedImageData</a>;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div><div class="line"><a name="l00174"></a><span class="lineno"><a class="line" href="protocol_s_d_animated_image_provider-p.html#a3796035c53913cff62cb385da86892bb">  174</a></span>&#160;<span class="keyword">@property</span> (nonatomic, assign, readonly) NSUInteger <a class="code" href="protocol_s_d_animated_image_provider-p.html#a3796035c53913cff62cb385da86892bb">animatedImageFrameCount</a>;</div><div class="line"><a name="l00180"></a><span class="lineno"><a class="line" href="protocol_s_d_animated_image_provider-p.html#acbd6e8bf73c986a6f562f0109b371701">  180</a></span>&#160;<span class="keyword">@property</span> (nonatomic, assign, readonly) NSUInteger <a class="code" href="protocol_s_d_animated_image_provider-p.html#acbd6e8bf73c986a6f562f0109b371701">animatedImageLoopCount</a>;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;- (nullable UIImage *)animatedImageFrameAtIndex:(NSUInteger)index;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;- (NSTimeInterval)animatedImageDurationAtIndex:(NSUInteger)index;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keyword">@end</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="preprocessor">#pragma mark - Animated Coder</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div><div class="line"><a name="l00204"></a><span class="lineno"><a class="line" href="protocol_s_d_animated_image_coder-p.html">  204</a></span>&#160;<span class="keyword">@protocol </span><a class="code" href="protocol_s_d_animated_image_coder-p.html">SDAnimatedImageCoder</a> &lt;<a class="code" href="protocol_s_d_image_coder-p.html">SDImageCoder</a>, <a class="code" href="protocol_s_d_animated_image_provider-p.html">SDAnimatedImageProvider</a>&gt;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="keyword">@required</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;- (nullable instancetype)initWithAnimatedImageData:(nullable NSData *)data options:(nullable SDImageCoderOptions *)options;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="keyword">@end</span></div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aprotocol_s_d_animated_image_provider-p_html_a3796035c53913cff62cb385da86892bb"><div class="ttname"><a href="protocol_s_d_animated_image_provider-p.html#a3796035c53913cff62cb385da86892bb">SDAnimatedImageProvider-p::animatedImageFrameCount</a></div><div class="ttdeci">NSUInteger animatedImageFrameCount</div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:174</div></div>
<div class="ttc" id="aprotocol_s_d_animated_image_provider-p_html"><div class="ttname"><a href="protocol_s_d_animated_image_provider-p.html">SDAnimatedImageProvider-p</a></div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:157</div></div>
<div class="ttc" id="aprotocol_s_d_animated_image_provider-p_html_a193999acb7f5c1c07a261ffee7820107"><div class="ttname"><a href="protocol_s_d_animated_image_provider-p.html#a193999acb7f5c1c07a261ffee7820107">SDAnimatedImageProvider-p::animatedImageData</a></div><div class="ttdeci">NSData * animatedImageData</div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:166</div></div>
<div class="ttc" id="aprotocol_s_d_animated_image_provider-p_html_acbd6e8bf73c986a6f562f0109b371701"><div class="ttname"><a href="protocol_s_d_animated_image_provider-p.html#acbd6e8bf73c986a6f562f0109b371701">SDAnimatedImageProvider-p::animatedImageLoopCount</a></div><div class="ttdeci">NSUInteger animatedImageLoopCount</div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:180</div></div>
<div class="ttc" id="aprotocol_s_d_animated_image_coder-p_html"><div class="ttname"><a href="protocol_s_d_animated_image_coder-p.html">SDAnimatedImageCoder-p</a></div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:204</div></div>
<div class="ttc" id="aprotocol_s_d_image_coder-p_html"><div class="ttname"><a href="protocol_s_d_image_coder-p.html">SDImageCoder-p</a></div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:56</div></div>
<div class="ttc" id="aprotocol_s_d_progressive_image_coder-p_html"><div class="ttname"><a href="protocol_s_d_progressive_image_coder-p.html">SDProgressiveImageCoder-p</a></div><div class="ttdef"><b>Definition:</b> SDImageCoder.h:114</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
